#ifndef _NRF24L01_H_
#define _NRF24L01_H_
#include <STC15F2K60S2.H>
#include "config.h"
//SPIӿ------------------  ʱΪ͵ƽ  һźŲɼ  ٶ10M-----------------------
/******************ӲSPI*************************************
#define MOSI    P13   
#define MISO    P14
#define SCLK    P15
*******************************************************************/

#define NRF24L01_IRQ     P10  // жź  ͵ƽΪжź
#define NRF24L01_CSN     P11  // SPI ʹź  Ƭѡź
#define NRF24L01_CE      P12  // ģʹź   ߵƽģʽ  ͵ģʽ  أ10us    ֻCEΪ͵ƽʱдĴ

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//NRF24L01Ĵ
#define READ_REG_NRF    0x00  //üĴ,5λΪĴַ
#define WRITE_REG_NRF   0x20  //дüĴ,5λΪĴַ
#define RD_RX_PLOAD     0x61  //RXЧ,1~32ֽ
#define WR_TX_PLOAD     0xA0  //дTXЧ,1~32ֽ
#define FLUSH_TX        0xE1  //TX FIFOĴ.ģʽ
#define FLUSH_RX        0xE2  //RX FIFOĴ.ģʽ
#define REUSE_TX_PL     0xE3  //ʹһ,CEΪ,ݰϷ.
#define NOP             0xFF  //ղ,״̬Ĵ	 
//SPI(NRF24L01)Ĵַ
#define CONFIG          0x00  //üĴַ;bit0:1ģʽ,0ģʽ;bit1:ѡ;bit2:CRCģʽ;bit3:CRCʹ;
                              //bit4:жMAX_RT(ﵽطж)ʹ;bit5:жTX_DSʹ;bit6:жRX_DRʹ
#define EN_AA           0x01  //ʹԶӦ  bit0~5,Ӧͨ0~5
#define EN_RXADDR       0x02  //յַ,bit0~5,Ӧͨ0~5
#define SETUP_AW        0x03  //õַ(ͨ):bit1,0:00,3ֽ;01,4ֽ;02,5ֽ;
#define SETUP_RETR      0x04  //Զط;bit3:0,Զط;bit7:4,Զطʱ 250*x+86us
#define RF_CH           0x05  //RFͨ,bit6:0,ͨƵ;
#define RF_SETUP        0x06  //RFĴ;bit3:(0:1Mbps,1:2Mbps);bit2:1,书;bit0:Ŵ
#define STATUS          0x07  //״̬Ĵ;bit0:TX FIFO־;bit3:1,ͨ(:6);bit4,ﵽط
                              //bit5:ݷж;bit6:ж;
//״̬б-------------															
#define MAX_TX  		  0x10  //ﵽʹж
#define TX_OK   		  0x20  //TXж
#define RX_OK   		  0x40  //յж

#define OBSERVE_TX      0x08  //ͼĴ,bit7:4,ݰʧ;bit3:0,ط
#define CD              0x09  //زĴ,bit0,ز;
#define RX_ADDR_P0      0x0A  //ͨ0յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P1      0x0B  //ͨ1յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P2      0x0C  //ͨ2յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P3      0x0D  //ͨ3յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P4      0x0E  //ͨ4յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P5      0x0F  //ͨ5յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define TX_ADDR         0x10  //͵ַ(ֽǰ),ShockBurstTMģʽ,RX_ADDR_P0˵ַ
//ͨЧݿ----------------------------
#define RX_PW_P0        0x11  //ͨ0Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P1        0x12  //ͨ1Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P2        0x13  //ͨ2Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P3        0x14  //ͨ3Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P4        0x15  //ͨ4Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P5        0x16  //ͨ5Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_FIFO_STATUS 0x17  //FIFO״̬Ĵ;bit0,RX FIFOĴձ־;bit1,RX FIFO־;bit2,3,
                              //bit4,TX FIFOձ־;bit5,TX FIFO־;bit6,1,ѭһݰ.0,ѭ;
//////////////////////////////////////////////////////////////////////////////////////////////////////////

//24L01ͽݿȶ
#define TX_ADR_WIDTH    5   	//5ֽڵĵַ
#define RX_ADR_WIDTH    5   	//5ֽڵĵַ
#define TX_PLOAD_WIDTH  32  	//32ֽڵûݿ
#define RX_PLOAD_WIDTH  32  	//32ֽڵûݿ

void  NRF24L01_Init(void);
u8    NRF24L01_Write_Reg(u8 reg,u8 value);          //ָĴд
u8    NRF24L01_Read_Reg(u8 reg);                    //Ĵ
u8    NRF24L01_Read_Buf(u8 reg,u8 *pBuf,u8 len);    //ָĴָ
u8    NRF24L01_Write_Buf(u8 reg, u8 *pBuf, u8 len); //ָĴдָ
//----------------------------------------------------------------------
void  NRF24L01_TX_Mode(void);                       //Ϊģʽ
u8    NRF24L01_TxPacket(u8 *txbuf);                 //һ  32ֽ
u8    NRF24L01_TxPacket_NUM(u8 *txbuf,u8 num);         //ָյַ0~5   5ΪĬϷ͵ַ
//--------------------------------------------------------------------
void  NRF24L01_RX_Mode(void);                       //Ϊģʽ
u8    NRF24L01_RxPacket(u8 *rxbuf,u8 *num);         //һ ״̬  ȡͨ



#endif

