#ifndef _SPI_CONT_H_
#define _SPI_CONT_H_
#include <STC15F2K60S2.H>
/*-----------------------------SPIؼĴ----------------------------------------------*/
// SPCTL ƼĴ   BIT7   BIT6  BIT5   BIT4   BIT3  BIT2 BIT1 BIT0
//                   SSIG   SPEN  DORD   MSTR   CPOL  CPHA SPR1  SPR0
#define SPI_STAT      0X40   //ʹSPI
#define SPI_FLASH     0x9C   //ʱӸߵƽ  ڶز  һλΪλ     CPU_CLK/4   δSPI

#define SPI_NRF24L01  0x90   //ʱӵ͵ƽ  һز  һλΪλ     CPU_CLK/4   δSPI

//SPSTAT  ״̬Ĵ    BIT7  SPIF   ɱ־    BIT6  дͻ־    Ӧλд1

// SPDAT  ݼĴ
// IE      BIT7  EA       жϿ
// IE2    жĴ    BIT1  ESPI   SPIжλ
// IP2    жȼƼĴ  BIT1  PSPI    0ȼж     1ȼ
// P_SW1/AUXR1   лƼĴ1   BIT3 BIT2  SPI_S1 SPI_S0   
// 00  P12 P13 P14 P15   01 P24 P23 P22 P21    10 P54 P40 P41 P43   11Ч   ŷֱӦ  SS  MOSI  MISO   SCLK

void SPI_Init(void);  //ʱӸߵƽ  ڶز  һλΪλ     CPU_CLK/4  
void SPI_SWITCH(unsigned char num); //SPIл 0 P12 P13 P14 P15, 1 P24 P23 P22 P21, 2 P54 P40 P41 P43  Ч ŷֱӦ  SS MOSI MISO SCLK
void SPI_SPEED(unsigned char num);  //SPI ٶ  0~3  0Ϊٶ

unsigned char SPI_WRITE_READ(unsigned dat);  //SPI дֽ






#endif
