#include "NRF24L01.h"

//͵ַ---------------------------------------------------------------------
code u8 TX_ADDRESS[TX_ADR_WIDTH]={0x00,0x43,0x10,0x10,0x01}; //͵ַ һֻһַ 5ֽڵַ  ʱRX_ADDR_P0ַͬ

//ַͨ-------------------------------------------------------------------------
code u8 RX_ADDRESS[6][5]={                //6ͨ     ÿͨ5ֽ  0͵1ַͨȫ 2~5ͨ8λ λͨ1ͬ
													{0x00,0x43,0x10,0x10,0x01},   //5ֽڵַȫ

													{0x01,0x43,0x10,0x10,0x01},   //ͨ1ַ  5ֽڵַȫ
													{0x02,0x43,0x10,0x10,0x01},   //ͨ2ַ  8λַ  λͨ1ͬ
													{0x03,0x43,0x10,0x10,0x01},   //ͨ3ַ  8λַ  λͨ1ͬ
													{0x04,0x43,0x10,0x10,0x01},   //ͨ4ַ  8λַ  λͨ1ͬ
													{0x05,0x43,0x10,0x10,0x01},   //ͨ5ַ  8λַ  λͨ1ͬ
                        };


//SPIдĴ
//reg:ָĴַ
//value:дֵ
u8 NRF24L01_Write_Reg(u8 reg,u8 value)
{
	  u8 status;	
   	NRF24L01_CSN=0;                 //ʹSPI
  	status =SPI_WRITE_READ(reg);//ͼĴ 
  	SPI_WRITE_READ(value);      //дĴֵ
  	NRF24L01_CSN=1;                 //ֹSPI	   
  	return(status);       			//״ֵ̬
}

//ȡSPIĴֵ
//reg:ҪļĴ
u8 NRF24L01_Read_Reg(u8 reg)
{
	u8 reg_val;	    
 	NRF24L01_CSN = 0;          //ʹSPI		
  SPI_WRITE_READ(reg);   //ͼĴ
  reg_val=SPI_WRITE_READ(0XFF);//ȡĴ
  NRF24L01_CSN = 1;          //ֹSPI		    
  return(reg_val);           //״ֵ̬
}	

//ָλöָȵ
//reg:Ĵ(λ)
//*pBuf:ָ
//len:ݳ
//ֵ,˴ζ״̬Ĵֵ 
u8 NRF24L01_Read_Buf(u8 reg,u8 *pBuf,u8 len)
{
	  u8 status,u8_ctr;	       
  	NRF24L01_CSN = 0;           //ʹSPI
  	status=SPI_WRITE_READ(reg);//ͼĴֵ(λ),ȡ״ֵ̬   	   
 	for(u8_ctr=0;u8_ctr<len;u8_ctr++)pBuf[u8_ctr]=SPI_WRITE_READ(0XFF);//
  	NRF24L01_CSN=1;       //رSPI
  	return status;        //ض״ֵ̬
}

//ָλдָȵ
//reg:Ĵ(λ)
//*pBuf:ָ
//len:ݳ
//ֵ,˴ζ״̬Ĵֵ
u8 NRF24L01_Write_Buf(u8 reg, u8 *pBuf, u8 len)
{
	u8 status,u8_ctr;	    
 	NRF24L01_CSN = 0;          //ʹSPI
  status = SPI_WRITE_READ(reg);//ͼĴֵ(λ),ȡ״ֵ̬
  for(u8_ctr=0; u8_ctr<len; u8_ctr++)SPI_WRITE_READ(*pBuf++); //д	 
  NRF24L01_CSN = 1;       //رSPI
  return status;          //ض״ֵ̬
}	

void  NRF24L01_Init(void)
{
  SPI_Init();      //ʼSPI
	SPI_SPEED(1);    //Լٶ   NRF24L01ٶ10M
  NRF24L01_CSN=1;  //رƬѡ
	NRF24L01_IRQ=1;  //жIO ߵƽ  Ч
	NRF24L01_CE=0;   //ģʽ  
}

void NRF24L01_TX_Mode(void)   //Ϊģʽ
{
   NRF24L01_CE=0;
   NRF24L01_Write_Buf(WRITE_REG_NRF+TX_ADDR,(u8*)TX_ADDRESS,TX_ADR_WIDTH);    //дTXַͨ  дַͨ
   NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P0,(u8*)TX_ADDRESS,RX_ADR_WIDTH); //TXַͨ,ҪΪʹACK	 뷢ַһ
	
	//  ֻҪͨ0ĽӦ𼴿     ԭ  ͬһʱֻһͨ
   NRF24L01_Write_Reg(WRITE_REG_NRF+EN_AA,0x01);     //ʹͨ0ԶӦ    
   NRF24L01_Write_Reg(WRITE_REG_NRF+EN_RXADDR,0x01); //ʹͨ0Ľյַ  
	
   NRF24L01_Write_Reg(WRITE_REG_NRF+RF_CH,40);       //RFͨΪ40   ձһ
   NRF24L01_Write_Reg(WRITE_REG_NRF+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪   
   NRF24L01_Write_Reg(WRITE_REG_NRF+CONFIG,0x0e);    //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ,ж  ϵ  ԶCRC
   NRF24L01_CE=1; 
}

//NRF24L01һ
//txbuf:׵ַ
//ֵ:״
u8 NRF24L01_TxPacket(u8 *txbuf)
{
	u8 sta; 
	NRF24L01_CE=0;     //ʹ
  NRF24L01_Write_Buf(WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);//дݵTX BUF  32ֽ
 	NRF24L01_CE=1;//	   
	
	while(NRF24L01_IRQ!=0);//ȴ
	
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ	   
	NRF24L01_Write_Reg(WRITE_REG_NRF+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&MAX_TX)//ﵽط
	{
		NRF24L01_Write_Reg(FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_TX; 
	}
	if(sta&TX_OK)//
	{
		return TX_OK;
	}
	return 0xff;//ԭʧ
}

//ַָͨ
//num 0~5 Ӧͨ6ַ  5Ϊ͵ַ
// txbuf  ݻ  32ֽ
//ֵ״̬  TX_OKɹ
u8 NRF24L01_TxPacket_NUM(u8 *txbuf,u8 num)
{
	NRF24L01_CE=0;
	
  if(num<=5)  //ַͨ
	{
   NRF24L01_Write_Buf(WRITE_REG_NRF+TX_ADDR,(u8*)RX_ADDRESS[num],TX_ADR_WIDTH);    //дTXַͨ  дַͨ
   NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P0,(u8*)RX_ADDRESS[num],RX_ADR_WIDTH); //TXַͨ,ҪΪʹACK	 뷢ַһ
  }
	else
	{
	 NRF24L01_Write_Buf(WRITE_REG_NRF+TX_ADDR,(u8*)TX_ADDRESS,TX_ADR_WIDTH);    //дTXַͨ  дַͨ
   NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P0,(u8*)TX_ADDRESS,RX_ADR_WIDTH); //TXַͨ,ҪΪʹACK	 뷢ַһ
	}
	NRF24L01_CE=1;
	
 return NRF24L01_TxPacket(txbuf);
}


//úʼNRF24L01RXģʽ  Ϊģʽ
//RXַ,дRXݿ,ѡRFƵ,ʺLNA HCURR
//CEߺ,RXģʽ,Խ		   
void NRF24L01_RX_Mode(void)
{
	//ע⣡P0ͨ 5ֽڵַȫ  P1ͨ5ֽڵַȫ  P2~P5ͨ Ͱλ  ֽP1ȫͬ
	  NRF24L01_CE=0;	  
  	NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P0,(u8*)RX_ADDRESS[0],RX_ADR_WIDTH);//дRXַͨ 0սͨ   ַ
	
  	NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P1,(u8*)RX_ADDRESS[1],RX_ADR_WIDTH);//дRXַͨ  ǳҪ1ͨҪд5λ  ַ
	
	//ͨ2~58λ   ֻдһֽ    λͨ1ַͬ-------------
  	NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P2,(u8*)RX_ADDRESS[2],1);
 	  NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P3,(u8*)RX_ADDRESS[3],1);
 	  NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P4,(u8*)RX_ADDRESS[4],1);
  	NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P5,(u8*)RX_ADDRESS[5],1);
	
	//ȫΪ32ֽڽտ-------------------------------------
		NRF24L01_Write_Reg(WRITE_REG_NRF+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ
	  NRF24L01_Write_Reg(WRITE_REG_NRF+RX_PW_P1,RX_PLOAD_WIDTH);//ѡͨ1Чݿ 	
	  NRF24L01_Write_Reg(WRITE_REG_NRF+RX_PW_P2,RX_PLOAD_WIDTH);//ѡͨ2Чݿ 	
	  NRF24L01_Write_Reg(WRITE_REG_NRF+RX_PW_P3,RX_PLOAD_WIDTH);//ѡͨ3Чݿ 	
	  NRF24L01_Write_Reg(WRITE_REG_NRF+RX_PW_P4,RX_PLOAD_WIDTH);//ѡͨ4Чݿ 	
	  NRF24L01_Write_Reg(WRITE_REG_NRF+RX_PW_P5,RX_PLOAD_WIDTH);//ѡͨ5Чݿ 	
		
	//ʹͨ-------------------------------------------------	
  	NRF24L01_Write_Reg(WRITE_REG_NRF+EN_AA,0x3f);    //ʹͨ0~5ԶӦ   	
  	NRF24L01_Write_Reg(WRITE_REG_NRF+EN_RXADDR,0x3f);//ʹͨ0~5Ľյַ  	 
  	NRF24L01_Write_Reg(WRITE_REG_NRF+RF_CH,40);	     //RFͨƵ
		
				
  	NRF24L01_Write_Reg(WRITE_REG_NRF+RF_SETUP,0x0f);//TX,0db,2Mbps,濪   
  	NRF24L01_Write_Reg(WRITE_REG_NRF+CONFIG, 0x0f);//ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ 
  	NRF24L01_CE = 1; //CEΪ,ģʽ 
}	

//NRF24L01һ
//txbuf:ջ׵ַ
//ֵ:0ɣ
u8 NRF24L01_RxPacket(u8 *rxbuf,u8 *num)
{
	u8 sta;		 
  if(NRF24L01_IRQ==0)	   //жж
	{
		sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ    	 
		NRF24L01_Write_Reg(WRITE_REG_NRF+STATUS,sta); //TX_DSMAX_RTжϱ־
		if(sta&RX_OK)//յ
		{
			*num=(sta>>1)&0x07;                 //ȡͨ
			NRF24L01_Read_Buf(RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
			NRF24L01_Write_Reg(FLUSH_RX,0xff);//RX FIFOĴ 
			return 0; 
		}	   
		return 1;//ûյκ
	}
	else
		return 1;
}	



