#ifndef _config_h_
#define _config_h_

#ifndef u8
#define u8  unsigned char
#endif
#ifndef u16
#define u16  unsigned int
#endif
#ifndef u32
#define u32  unsigned long
#endif

#ifndef BIT0
#define BIT0  0X01
#define BIT1  0X02
#define BIT2  0X04
#define BIT3  0X08
#define BIT4  0X10
#define BIT5  0X20
#define BIT6  0X40
#define BIT7  0X80
#define BIT04 (BIT0+BIT4)
#define BIT15 (BIT1+BIT5)
#define BIT26 (BIT2+BIT6)
#define BIT37 (BIT3+BIT7)
#endif

#include "intrins.h"
#ifndef nop
#define nop    _nop_()
#endif

#include <STC15F2K60S2.H>
#include "NRF24L01.h"
#include "SPI_CONT.h"
#include "Uart.h"

#endif
